//Authors: S.Venkatesan, Sandeep Kumar Shukla and Yuvaraj Rajendra
package ini
import (
		"fmt"
		"time"
		"math/rand"
		"variables"
       )


func Randomrangeint(from int, to int) int {
	var randno int
	tog := to + 1
	for ; ; {
		rand.Seed(time.Now().UnixNano())
		randno = rand.Intn(tog)
		if randno <= to && randno >= from {
			break;
		}
	}
	return randno
}

func Randomrangefloat(from float64, to float64) float64 {
	var randno int 
	//var rangefrom int
	rangefrom :=  int(from)
	tog := int(to) + 1
	for ; ; {
		rand.Seed(time.Now().UnixNano())
		randno = rand.Intn(int(tog))
		if randno <= int(to) && randno >= rangefrom {
			break;	
		}
	}
	return float64(randno)
}

func Randomignorevalue(from int, to int, ignore int) int {
	var randno int
	tog := to + 1
	for ; ; {
		rand.Seed(time.Now().UnixNano())
		randno = rand.Intn(tog)
		if randno <= to && randno >= from && randno != ignore{
			break;
		}
	}
	return randno
}


// This function gives unique neighbors for the nodes 
func UniqueRand(node int) {
	if node  > vars.Mn + vars.Dn +1 && node <= vars.Mn + vars. Dn + vars.Sn {  // this for making all sybil node to get the same neighbors
			vars.Nodeneighbor[node] = vars.Nodeneighbor[node -1]
	} else {
		for i := 0; i < vars.Mnei; i++ {
			rand.Seed(time.Now().UnixNano())
			vars.Nodeneighbor[node][i+1] = Randomrangeint(1,vars.N)
			if vars.Nodeneighbor[node][i+1] == node {
				i--;
				continue;
			}
			if vars.Nloc == 1 || vars.Nloc == 2 {
			//if vars.Nloc >= 1 {
				if vars.Nodeactive[node][4] != vars.Nodeactive[vars.Nodeneighbor[node][i+1]][4] {
					i--;
					continue;
				}	
			}
			for j := 1; j < i+1 ; j++ {
				if vars.Nodeneighbor[node][j] == vars.Nodeneighbor[node][i+1] {
					i--;
					break;
				}
			}
		}
		vars.Nodeneighbor[node][0] =  vars.Mnei;
		for i := vars.Mnei + 1; i < vars.Nodesize; i++ {
			vars.Nodeneighbor[node][i] = -1
		} 
	}
}

//Initialize the node entry that is to ensure it is empty in the beginning by giving the expired as -1
func Nodeinitialize() {
	for i := 1; i < vars.Nodesize; i++ {
		for j := 0; j < vars.N * vars.Ne ; j++ {
			vars.Nodemain[i][j][0] = -1
			vars.Nodemain[i][j][1] = -1
			vars.Nodemain[i][j][6] = -1
			vars.Nodemain[i][j][10] = -1
		}
	}
}



//Initial resource fixing for each device
// This function allot the resources for the nodes according to its behaviour
// vars.Nodeservice[][1][0] refers the service 1 is applicable or not; -1 not applicable, 0 or 1 or .. service values. At present it is only -1, and 1 that is available 1 not available -1
// vars.Nodeservice[][][1] refers malicious or genuine; 2 sybil, 1 disguise, 3 genuine and 0 malicious;
// vars.Nodeservice[][][2] refers status id; for example, 0 open, 1 not open;
// vars.Nodeservice[][][3] refers correct or incorrect service; for example, -1 incorrect service, 1 correct service;
// vars.Nodeservice[][][4] refers data ownership; from whom this data has come that is its own or sent by some one
func Resource() {
	fmt.Println("######### Node Service Allocation #########")
	var eligible int
	var svalue int
	ranseed := 50
	for s := 1; s <= vars.N; s++  {
		vars.Nodeactive[s][0] = 1 // 1 indicates node is active
		vars.Nodeactive[s][1] = s // indicates introducer. In case of old node then introducer is same as the node id
		if s <= vars.Mn {  //Malicious Nodes
			//fmt.Println("Malicious Nodes---------------")
			noofnodes := 1

			if vars.Collude == 1 && s <= vars.Colnode{
				noofnodes = vars.Colnode
			}
			vars.Nodeactive[s][2] = 0 // indicates malicious node
			for i := 0; i < vars.Mi; i++ {
				rand.Seed(time.Now().UnixNano())
				eligible = rand.Intn(ranseed)%2

				if eligible == 1 {
					//for j := 0; j < 1000; j++ { //in 1000 attempt non-correct status value will be identified
                                        svalue = Randomignorevalue(0, vars.Nsv[i], vars.Nodeservicetable[i][0])
						//rand.Seed(time.Now().UnixNano())
					//	svalue = rand.Intn(vars.Nsv[i])
					//	if svalue != vars.Nodeservicetable[i][0] {
						for k := 0; k < noofnodes; k++ { 
							recur := s + k
							vars.Nodeactive[recur][0] = 1 // 1 indicates node is active
                                                        vars.Nodeactive[recur][1] = recur // indicates introducer. In case of old node then introducer is same as the node id
							if(vars.Nloc > 1) { // assigninign lcoation
								vars.Nodeactive[recur][4] = Randomrangeint(0, vars.Numloc) 
							} else {
								vars.Nodeactive[recur][4] = 0
							}

							vars.Nodeservice[recur][i][0] = 1
							vars.Nodeservice[recur][i][1] = 0
							vars.Nodeservice[recur][i][2] = svalue
							vars.Nodeservice[recur][i][3] = -1
							vars.Nodeservice[recur][i][4] = s
						}
						//	break
					//	}
					//}
				} else {
					vars.Nodeservice[s][i][0] = -1
					vars.Nodeservice[s][i][1] = 0
				}
			}
			if vars.Collude == 1 && s <= vars.Colnode{
				s = s + vars.Colnode - 1
			}
		} else if s > vars.Mn && s <= vars.Mn + vars.Dn {  // Disguised Nodes
			//fmt.Println("Disguised Nodes---------------")
			vars.Nodeactive[s][2] = 1 // indicates disguised node
			if(vars.Nloc > 1) {
				vars.Nodeactive[s][4] = Randomrangeint(0, vars.Numloc) 

			} else {
				
				vars.Nodeactive[s][4] = 0
			}
			vars.Nodeactive[s][5] = Randomrangeint(1, vars.Nonodegroup)// to decide whether a group belongs to private or publick 
			for i := 0; i < vars.Mi; i++ {
				rand.Seed(time.Now().UnixNano())
				eligible = rand.Intn(ranseed)%2
				if eligible == 1 {
					rand.Seed(time.Now().UnixNano())
					disguisedecision := rand.Intn(2)
					if disguisedecision == 1 {
						vars.Nodeservice[s][i][0] = 1
						vars.Nodeservice[s][i][1] = 1
						vars.Nodeservice[s][i][2] = vars.Nodeservicetable[i][0]
						vars.Nodeservice[s][i][3] = 1
						vars.Nodeservice[s][i][4] = s

					} else {
						//for j := 0; j < 1000; j++ { //in 1000 attempt non-correct status value will be identified
                	                        //        rand.Seed(time.Now().UnixNano())
                                         	svalue = Randomignorevalue(0, vars.Nsv[i], vars.Nodeservicetable[i][0])
                        	                //        svalue = rand.Intn(vars.Nsv[i])
                                	         //       if svalue != vars.Nodeservicetable[i][0] {
								vars.Nodeservice[s][i][0] = 1
								vars.Nodeservice[s][i][1] = 1
								vars.Nodeservice[s][i][2] = svalue
								vars.Nodeservice[s][i][3] = -1
								vars.Nodeservice[s][i][4] = s
						//		break
						//	}
						//}
					}
				} else {
					vars.Nodeservice[s][i][0] = -1
					vars.Nodeservice[s][i][1] = 1
				}
			}
		} else if s > vars.Mn + vars.Dn && s <= vars.Mn + vars.Dn + vars.Sn {  // Sybil Nodes
			//fmt.Println("Sybil Nodes ------------------")
			vars.Nodeactive[s][2] = 1 // indicates sybil node
			noofnodes := 1
			if vars.Bsm == 1 {
				noofnodes = vars.Sn
			}
			for i := 0; i < vars.Mi; i++ {
				rand.Seed(time.Now().UnixNano())
				eligible = rand.Intn(ranseed)%2
				if eligible == 1 {
					//for j := 0; j < 1000; j++ { //in 1000 attempt non-correct status value will be identified
                                               // rand.Seed(time.Now().UnixNano())
                                                //svalue = rand.Intn(vars.Nsv[i])
                                         	svalue = Randomignorevalue(0, vars.Nsv[i], vars.Nodeservicetable[i][0])
                                                //if svalue != vars.Nodeservicetable[i][0] {
							for k := 0; k < noofnodes; k++ {
								recur := s + k
								vars.Nodeactive[recur][0] = 1 // 1 indicates node is active
								vars.Nodeactive[recur][1] = recur // indicates introducer. In case of old node then introducer is same as the node id
								if(vars.Nloc > 1) {
									vars.Nodeactive[recur][4] = Randomrangeint(0, vars.Numloc) 
								} else {
									vars.Nodeactive[recur][4] = 0
								}
								vars.Nodeservice[recur][i][0] = 1
	                                                        vars.Nodeservice[recur][i][1] = 2
	                                                        vars.Nodeservice[recur][i][2] = svalue
	                                                        vars.Nodeservice[recur][i][3] = -1
								vars.Nodeservice[s+k][i][4] = s
							}
						//	break
                                               // }
                                       // }
				} else {
					for k := 0; k < noofnodes; k++ { 
						vars.Nodeservice[s+k][i][0] = -1
						vars.Nodeservice[s+k][i][1] = 2
					}
				}
			}
			if vars.Bsm == 1 {
                               s = s + vars.Sn - 1
                        }
		} else if  s > vars.Mn + vars.Dn + vars.Sn {
			//fmt.Println("Genuine Nodes ---------------")
			vars.Nodeactive[s][2] = 3 // indicates genuine node
			vars.Nodeactive[s][5] = Randomrangeint(1, vars.Nonodegroup)// to decide whether a group belongs to private or publick 
			if(vars.Nloc > 1) {
				vars.Nodeactive[s][4] = Randomrangeint(0, vars.Numloc) 
			} else {
				vars.Nodeactive[s][4] = 0
			}
			for i := 0; i < vars.Mi; i++ {
				rand.Seed(time.Now().UnixNano())
				//eligible = rand.Intn(2)
				//eligible = rand.Intn(ranseed)%2
				eligible = rand.Intn(ranseed)%2
				//fmt.Println(eligible)
				if eligible == 1 {
					vars.Nodeservice[s][i][0] = 1
					vars.Nodeservice[s][i][1] = 3
					vars.Nodeservice[s][i][2] = vars.Nodeservicetable[i][0]
					vars.Nodeservice[s][i][3] = 1
					vars.Nodeservice[s][i][4] = s
				} else {
					vars.Nodeservice[s][i][0] = -1
					vars.Nodeservice[s][i][1] = 3
				}
			}
			//fmt.Println(ks)
			//fmt.Println(vars.Nodeservice[s])
		}
		//fmt.Println(s,"--",vars.Nodeservice[s])
	}
	for s := vars.N+1; s < vars.Nodesize; s++ {
		for i := 0; i < vars.Mi; i++ {
				vars.Nodeservice[s][i][0] = -1
		}
	}
	/*nodetype := 0
	for s = 1; s <= maxflynode; s++ {
		rand.Seed(time.Now().UnixNano())
                nodetype = rand.Intn(4)
		for i := 0; i < mi; i++ {
			rand.Seed(time.Now().UnixNano())
			eligible = rand.Intn(2)
			if eligible == 1 {
				vars.Nodeservice[s][i][0] = 1
				if nodetype == 0 && mn > 0 {  //malicious node
					vars.Nodeservice[s][i][1] = 0
					vars.Nodeservice[s][i][3] = -1
				}else if nodetype == 1 && dn > 0 {  //disguised node
					vars.Nodeservice[s][i][1] = 1
					rand.Seed(time.Now().UnixNano())
      					decision = rand.Intn(2)
					if decision == 0 {
						vars.Nodeservice[s][i][3] = -1
					}else {
						vars.Nodeservice[s][i][3] = 1
					}
				} else if nodetype == 2 && sn > 0 {  // sybil node
					vars.Nodeservice[s][i][1] = 2
					vars.Nodeservice[s][i][3] = -1
				} else {
					vars.Nodeservice[s][i][1] = 3
					vars.Nodeservice[s][i][3] = 1
				}
			}
			else {
				vars.Nodeservice[s][i][0] = -1

			}
		}
	}*/
	//os.Exit(1);
	value := -1
	for lk := 1; lk <= vars.N; lk++ {
		for ik := 0; ik < vars.Mi; ik++ {
			if vars.Nodeservice[lk][ik][0] == 1 {
				value = vars.Nodeservice[lk][ik][2]
			} else {
				value = -1
			} 
			for jk := vars.Nsa; jk < vars.Nsa + vars.Nf; jk++ {
               		 	vars.Nodeservice[lk][ik][jk] = value
			}
		}
		//fmt.Println(lk,vars.Nodeservice[lk])
	}
}


//Intializing the fact table with -1
// array 0,  
func Factinitialize() {
	for i := 0; i < vars.Fsize; i++ {
		vars.Fact1[i][0] = -1
		vars.Fact1[i][1] = -1
		vars.Fact1[i][4] = -1
	}

}


// Initialize the trust compute table. Maximum number of votes allowed for each node is
// total node * total node
func Nodetrustinitialize() {
	for fu := 0; fu < vars.Nf; fu++ {
		for i := 1; i <= vars.N; i++ {
			for j := 1; j < vars.Nodesize * vars.Nodesize; j++ { 
				vars.Tcompute[fu][i][j][0] = -1
				vars.Tcompute[fu][i][j][2] = -1
			}
		}
	}
}

// Initialize the node table. 
func Nodemaininitialize() {
	for i := 1; i < vars.Nodesize; i++ { 
		for j := 1; j <= vars.N * vars.Ne; j++  {
			vars.Nodemain[i][j][1] = -1
			vars.Nodemain[i][j][0] = -1
			vars.Nodemain[i][j][10] = -1
		}
	}
}

//Collude entry table initialize
func Colludeentryinitialize() {
	vars.Colludeindex = 0
	for i := 0; i < vars.Colludeentry; i++ { 
		vars.Colludearray[i][0] = -1
		for j := 1; j <= vars.Colnode; j++ {
			vars.Colluderbloom[j][0][i] = 0
			vars.Colluderbloom[j][1][i] = 0
			vars.Colluderbloom[j][2][i] = 0
		}
	}
}

//Collude entry table initialize
func Sybilentryinitialize() {
	vars.Sybilindex = 0
	for i := 0; i < vars.Sybilentry; i++ { 
		vars.Sybilarray[i][0] = -1
		for j := 1; j <= vars.Sn; j++ {
			vars.Sybilbloom[j][0][i] = 0
			vars.Sybilbloom[j][1][i] = 0
			vars.Sybilbloom[j][2][i] = 0
		}

	}
}


//initializing the score of the nodes
func Scoreinitialize() {
	for fu := 0; fu < vars.Nf; fu++ {
		for i := 1; i <= vars.N;  i++ {
			for j := 0; j < vars.Tsa + vars.Tsae;  j++ {
				vars.Tscore[fu][i][j] = 0 // Initializing the whole entry as zero 
			}	
		}
	}
}

